%define accountmajor	0
%define libaccount	%mklibname account %{accountmajor}
%define libaccountdevel	%mklibname account -d

Name:		xtables-addons
Version:	2.5
Release:	%mkrel 1
Summary:	Extensions that were not, or are not yet, accepted in the main kernel/iptables packages
Group:		System/Kernel and hardware
License:	GPLv2
URL:		http://xtables-addons.sourceforge.net/
Source0: 	http://downloads.sourceforge.net/xtables-addons/%{name}-%{version}.tar.xz
Source1: 	http://downloads.sourceforge.net/xtables-addons/%{name}-%{version}.tar.asc
Provides:	iptables-addons = %{version}-%{release}

BuildRequires:	pkgconfig(xtables) >= 1.4.5
BuildRequires:	kernel >= 3.7
Requires:	kernel >= 3.7
Suggests:	iptaccount
Suggests:	xtables-geoip

%description
Xtables-addons is the successor to patch-o-matic(-ng). Likewise, it contains
extensions that were not, or are not yet, accepted in the main kernel/iptables
packages.

Xtables-addons is different from patch-o-matic in that you do not have to
patch or recompile the kernel, sometimes recompiling iptables is also not
needed. But please see the INSTALL file for the minimum requirements of this
package.

(The name stems from Xtables, which is the protocol-agnostic code part of the
table-based firewalling schema.)


%package -n iptaccount
Summary:	Helper example program for iptables accounting
Group:		System/Kernel and hardware
Requires:	%{libaccount} == %{version}-%{release}

%description -n iptaccount
Helper example program for iptables accounting using the ACCOUNT target.


%package -n xtables-geoip
Summary:	Helper scripts for using geoip in iptables
Group:		System/Kernel and hardware
Requires:       kmod(xt_geoip) = %{version}
Requires:       %{name} = %{version}-%{release}
BuildArch:	noarch

%description -n xtables-geoip
Helper scripts for using geoip in iptables.


%package -n %{libaccount}
Summary:	Library for iptaccount
Group:		System/Kernel and hardware
Requires:       kmod(xt_ACCOUNT) = %{version}
Requires:       %{name} = %{version}-%{release}

%description -n %{libaccount}
Library for iptaccount. iptaccount is a helper example program for iptables
accounting using the ACCOUNT target.


%package -n %{libaccountdevel}
Summary:	Development library for iptaccount
Group:		System/Kernel and hardware
Requires:	%{libaccount} == %{version}-%{release}

%description -n %{libaccountdevel}
Development library for iptaccount. iptaccount is a helper example program
for iptables accounting using the ACCOUNT target.


%package -n dkms-%{name}
Summary:	dkms package for xtables-addons
Group:		System/Kernel and hardware
Requires:	dkms
Requires:	kernel-devel >= 3.7
Requires(post):	dkms
Requires(preun):dkms

%description -n dkms-%{name}
This contains the dkms package building the xtables-addons kernel modules.

Xtables-addons is the successor to patch-o-matic(-ng). Likewise, it contains
extensions that were not, or are not yet, accepted in the main kernel/iptables
packages.

Xtables-addons is different from patch-o-matic in that you do not have to
patch or recompile the kernel, sometimes recompiling iptables is also not
needed. But please see the INSTALL file for the minimum requirements of this
package.

(The name stems from Xtables, which is the protocol-agnostic code part of the
table-based firewalling schema.)


%prep
%setup -q
%apply_patches

%build
# don't build the modules
%configure2_5x --without-kbuild
%make

%install
%makeinstall_std

# we don't package .la
rm -f %{buildroot}%{_libdir}/libxt_ACCOUNT_cl.la

# prepare the dkms sources
mkdir -p %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/ACCOUNT %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/pknock
cp extensions/Kbuild extensions/Mbuild mconfig extensions/Makefile* extensions/mac.c extensions/xt_* extensions/compat_* %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}
cp extensions/ACCOUNT/Kbuild extensions/ACCOUNT/Mbuild extensions/ACCOUNT/Makefile* extensions/ACCOUNT/xt_* %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/ACCOUNT
cp extensions/pknock/Kbuild extensions/pknock/Mbuild extensions/pknock/Makefile* extensions/pknock/xt_* %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/pknock

# mconfig is not in parent dir anymore
sed -i 's/${XA_ABSTOPSRCDIR}/${M}/' %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/Kbuild

# remove ipset-6 references to silence make clean errors
sed -i '/ipset-6/ d' %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/Kbuild
sed -i '/ipset-6/ d' %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/Mbuild

cat > %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/dkms.conf << EOF
PACKAGE_NAME="%{name}"
PACKAGE_VERSION="%{version}-%{release}"
AUTOINSTALL="yes"
MAKE[0]="make -C \${kernel_source_dir} M=\\\$(pwd)"
CLEAN="make -C \${kernel_source_dir} M=\\\$(pwd) clean"
BUILT_MODULE_LOCATION[0]="ACCOUNT"
DEST_MODULE_LOCATION[0]="/kernel/extra"
BUILT_MODULE_NAME[0]="xt_ACCOUNT"
BUILT_MODULE_LOCATION[1]="pknock"
DEST_MODULE_LOCATION[1]="/kernel/extra"
BUILT_MODULE_NAME[1]="xt_pknock"
EOF

i=2
for mod in compat_xtables xt_CHAOS \
xt_condition xt_DELUDE xt_DHCPMAC xt_DNETMAP xt_fuzzy xt_geoip xt_iface \
xt_IPMARK xt_ipp2p xt_ipv4options xt_length2 xt_LOGMARK xt_lscan xt_psd \
xt_quota2 xt_SYSRQ xt_TARPIT; do
	echo -e "DEST_MODULE_LOCATION[$i]=\"/kernel/extra\"\nBUILT_MODULE_NAME[$i]=\"$mod\"" >> %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/dkms.conf
	(( i = $i + 1 ))
done

cat > README.urpmi <<EOF

NOTE1: Be careful, since the xt_ACCOUNT module seems not to be loaded, if
you have shorewall, you'll need to put this module in shorewalls
modules.xtables file.

NOTE2: if you're using shorewall, you can put the following in the
/etc/shorewall/accounting file:

SECTION PREROUTING
ACCOUNT(down,0.0.0.0/0)		-	eth0	-
ACCOUNT(local,192.168.0.0/24)	-	eth1	-
SECTION POSTROUTING
ACCOUNT(up,0.0.0.0/0)		-	-	eth0
ACCOUNT(local,192.168.0.0/24)	-	-	eth1

(assuming you have a LAN 192.168.0.0/24 on eth1 and internet on eth0)

[]# iptables -l down (will show your total downstream traffic in the src)
[]# iptables -l up (will show your total upstream traffic in the src section)
[]# iptables -l local (will show your up/downstream traffic per ip address)

(special case 0.0.0.0/0 will have all traffic always in src)

EOF

%post -n dkms-%{name}
set -x
/usr/sbin/dkms add     -m %{name} -v %{version}-%{release} --rpm_safe_upgrade &&
/usr/sbin/dkms build   -m %{name} -v %{version}-%{release} --rpm_safe_upgrade &&
/usr/sbin/dkms install -m %{name} -v %{version}-%{release} --rpm_safe_upgrade --force
true

%preun -n dkms-%{name}
set -x
/usr/sbin/dkms remove  -m %{name} -v %{version}-%{release} --rpm_safe_upgrade --all
true

%files
%doc LICENSE README INSTALL
/%{_lib}/iptables/libxt_*.so
%{_mandir}/man8/xtables-addons.8.xz

%files -n dkms-%{name}
%{_usr}/src/%{name}-%{version}-%{release}

%files -n iptaccount
%doc README.urpmi
%{_sbindir}/iptaccount
%{_mandir}/man8/iptaccount.8*

%files -n %libaccount
%{_libdir}/libxt_ACCOUNT_cl.so.%{accountmajor}
%{_libdir}/libxt_ACCOUNT_cl.so.%{accountmajor}.*

%files -n %libaccountdevel
%{_libdir}/libxt_ACCOUNT_cl.so

%files -n xtables-geoip
%{_libexecdir}/xtables-addons/xt_geoip_build
%{_libexecdir}/xtables-addons/xt_geoip_dl
%{_mandir}/man1/xt_geoip_build.1*
%{_mandir}/man1/xt_geoip_dl.1*


%changelog
* Tue Aug 26 2014 tmb <tmb> 2.5-1.mga4
+ Revision: 668468
- update to 2.5 (kernel-3.14 support)

* Sat Oct 19 2013 umeabot <umeabot> 2.3-3.mga4
+ Revision: 531841
- Mageia 4 Mass Rebuild

* Sun Aug 11 2013 tmb <tmb> 2.3-2.mga4
+ Revision: 465461
- rebuild with new gcc

* Mon Jul 15 2013 tmb <tmb> 2.3-1.mga4
+ Revision: 454782
- update to 2.3 (kernel 3.10 support)

* Wed Jun 05 2013 fwang <fwang> 2.2-2.mga4
+ Revision: 437501
- rebuild for new iptables

* Sun Jun 02 2013 tmb <tmb> 2.2-1.mga4
+ Revision: 435167
- update to 2.2 (kernel-3.9 support)

* Mon Jan 14 2013 umeabot <umeabot> 2.1-3.mga3
+ Revision: 387441
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Jan 10 2013 tmb <tmb> 2.1-2.mga3
+ Revision: 344823
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Jan 05 2013 alien <alien> 2.1-1.mga3
+ Revision: 339354
- Update to new version 2.1

* Sat Jan 05 2013 alien <alien> 2.0-2.mga3
+ Revision: 339332
- Move geoip helper scripts into libexecdir and set it noarch

  + fwang <fwang>
    - only support 3.7+ now
    - new version 2.0 for 3.7 kernels

* Fri Dec 07 2012 tmb <tmb> 1.47.1-5.mga3
+ Revision: 327662
- fix build with kernel-3.7 (P0)

* Sat Nov 17 2012 tmb <tmb> 1.47.1-4.mga3
+ Revision: 319216
- drop uselessly added self-obsolete on dkms-xtables-addons
- drop unwanted require on kernel < 3.7

* Sat Nov 17 2012 fwang <fwang> 1.47.1-3.mga3
+ Revision: 319154
- obsoletes old packages

* Sat Nov 17 2012 fwang <fwang> 1.47.1-2.mga3
+ Revision: 319144
- the makefile in dkms package acturally different

* Thu Nov 15 2012 fwang <fwang> 1.47.1-1.mga3
+ Revision: 318151
- requires kernel < 3.7
- new version 1.47.1

* Thu Nov 15 2012 fwang <fwang> 2.0-1.mga3
+ Revision: 318145
- new version 2.0

* Thu Nov 08 2012 fwang <fwang> 1.45-2.mga3
+ Revision: 316287
- rebuild for new iptables

* Sat Jul 21 2012 alien <alien> 1.45-1.mga3
+ Revision: 273168
- Update to version 1.45
- Remove unneeded patch

* Sun Apr 08 2012 alien <alien> 1.41-3.mga2
+ Revision: 229738
- add documentation on how to use iptaccount

* Sun Apr 08 2012 alien <alien> 1.41-2.mga2
+ Revision: 229698
- geoip and iptaccount require xtables-addons

* Fri Apr 06 2012 alien <alien> 1.41-1.mga2
+ Revision: 229386
- imported package xtables-addons

